"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const render_1 = require("./render");
const mount_1 = require("./mount");
/** render wrapper */
function _r(props) {
    return render_1.render(this, this.instance, props);
}
/** wrapped mount */
function _wm(options) {
    const targetElement = mount_1._m(this.instance, this, options === null || options === void 0 ? void 0 : options.target, options === null || options === void 0 ? void 0 : options.props);
    const els = this.els;
    if (!els.includes(targetElement)) {
        els.push(targetElement);
    }
    return targetElement;
}
/** wrapped _u */
function _wu(options) {
    mount_1._u(this.instance, this, options === null || options === void 0 ? void 0 : options.target);
}
/** traverse */
function _t(children, flattenedNodes) {
    children.forEach(child => {
        if (Array.isArray(child)) {
            _t(child, flattenedNodes);
        }
        else {
            flattenedNodes.push(child);
        }
    });
}
/** flatten */
function _f(children) {
    if (children === null)
        return null;
    const flattenedNodes = [];
    _t(children, flattenedNodes);
    return flattenedNodes;
}
/** create CNode */
function _cc(instance, $, props, children) {
    return {
        instance,
        $,
        props,
        children: _f(children),
        els: [],
        render: _r,
        mount: _wm,
        unmount: _wu
    };
}
exports.c = function (instance, $, props, children) {
    if (Array.isArray($)) {
        return _cc(instance, '', null, $);
    }
    if (Array.isArray(props)) {
        return _cc(instance, $, null, props);
    }
    else if (Array.isArray(children)) {
        return _cc(instance, $, props, children);
    }
    else {
        return _cc(instance, $, props, null);
    }
};
